//+------------------------------------------------------------------+
//|                                              dex_CycleWPR_v1.mq4 |
//|                                                                  |
//|                                                                  |
//|  C ,  (akadex)                              2008 |
//+------------------------------------------------------------------+

#property copyright "akadex"
#property link      "Shambala"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 SkyBlue
#property indicator_minimum 0
#property indicator_maximum 1

extern int MAShort=12;
extern int MALong=24;
extern int HL=24;
extern bool Level=true;      
extern double Level1        = 0.75;
extern double Level2        = 0.50;
extern double Level3        = 0.25;
extern color  LevelsColor   = C'30,33,36';

double Buffer[],Buffer1[];
string ShortName;


int init() {

   IndicatorBuffers(2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1); 
   SetIndexBuffer(0,Buffer);
   SetIndexBuffer(1,Buffer1);
   
   ShortName=("dex_CycleWPR_v1 | ("+MAShort+" | "+MALong+")");
   IndicatorShortName(ShortName);

   return(0); 
}


int deinit()
{
   if (Level) DeleteBounds();
   return(0); 
}


int start() 
{
   int limit,i,counted_bars=IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit>Bars-MALong) limit=Bars-MALong;
   if (Level)UpdateBounds();
   for (i = limit;i>=0;i--)
   {

   Buffer1[i]=iMA(NULL,0,MAShort,0, MODE_EMA, PRICE_CLOSE, i)-iMA(NULL,0,MALong,0, MODE_EMA, PRICE_CLOSE, i);
   double Min=Buffer1[ArrayMinimum(Buffer1,HL,i)];
   double Max=Buffer1[ArrayMaximum(Buffer1,HL,i)];
 
   if (Min==Max) Buffer[i] = 0;
   else Buffer[i]=(Buffer1[i]-Min)/(Max-Min);
 
   }
   return(0); 
}


void DeleteBounds()
{
   ObjectDelete(ShortName+"-1");
   ObjectDelete(ShortName+"-2");
   ObjectDelete(ShortName+"-3");
}

void UpdateBounds()
{
   if (Level1 > 0) SetUpBound(ShortName+"-1",1.0000,Level1);
   if (Level2 > 0) SetUpBound(ShortName+"-2",Level2*1.015,Level2*0.995);
   if (Level3 > 0) SetUpBound(ShortName+"-3",Level3,0.0000);
}

void SetUpBound(string name, double up, double down,int objType=OBJ_RECTANGLE)
{
   if (ObjectFind(name) == -1)
      {
         ObjectCreate(name,objType,WindowFind(ShortName),0,0);
         ObjectSet(name,OBJPROP_PRICE1,up);
         ObjectSet(name,OBJPROP_PRICE2,down);
         ObjectSet(name,OBJPROP_COLOR,LevelsColor);
         ObjectSet(name,OBJPROP_BACK,true);
         ObjectSet(name,OBJPROP_TIME1,iTime(NULL,0,Bars-1));
      }
   if (ObjectGet(name,OBJPROP_TIME2) != iTime(NULL,0,0))
       ObjectSet(name,OBJPROP_TIME2,    iTime(NULL,0,0));
}